; ***** BEGIN LICENSE BLOCK *****
; * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; *
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; * GNU General Public License for more details.
; *
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
; ***** END LICENSE BLOCK *****

(document:surround "/std/frame")

(define (progress-monitor msg)
  (case (cond-car msg)
    ((error)
     (remove-mailbox progress-monitor)
     (status-l text (format #f "<font color=\"red\"><b>~A:</b></font><br/><p>~A</p>"
                            (_ "Execution of script failed")
                            (or (cond-cadr msg) "unknown")))
     (frame:next-activity #t)
     (frame:back-activity #t))
    ((init)
     (progress text (_ "Saving settings ..."))
     (progress maximum (cond-plistq 'max msg 0)))

    ((done)
     (remove-mailbox progress-monitor)
     (frame:next))

    ((package)
     (progress value (cond-plistq 'step msg 0)))))

(vbox max-height 150
      (spacer)
      (document:id progress (progressbar maximum 0 value 0 text " "))
      (document:id status-l (label))
      (spacer))

(document:root (when loaded
                 (add-mailbox progress-monitor)
                 (frame:next-activity #f)
                 (frame:back-activity #f)
		 (woo-write "/preinstall")))
